﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
    public class Awake5 : MonoBehaviour
    {
        public LimbBehaviour limb;
        public Boolean Nullified = false;

        public void Start()
        {
            limb = GetComponent<LimbBehaviour>();
            PhysicalBehaviour physicalBehaviour = limb.PhysicalBehaviour;
            StartCoroutine(lechenie(limb));



        }



        private IEnumerator lechenie(LimbBehaviour limb)
        {
            while (Nullified == false)
            {
                limb.Health = limb.InitialHealth * 100000f;
                limb.Numbness = 0f;
                limb.CirculationBehaviour.HealBleeding();
                limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
                limb.CirculationBehaviour.BloodFlow = 600f;
                limb.CirculationBehaviour.BloodAmount = 600f;
                limb.BruiseCount = (ushort)0;
                limb.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 5f;
                limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                limb.CirculationBehaviour.StabWoundCount = (ushort)0;
                StartCoroutine(naxuiogon(limb));
                limb.Person.Consciousness = 5f;
                limb.Person.OxygenLevel = 1000f;
                StartCoroutine(naxuipuli(limb));
                limb.Person.AdrenalineLevel = 0f;
                limb.Person.ShockLevel = 0f;
                StartCoroutine(naxuirani(limb));
                StartCoroutine(naxuignoi(limb));
                StartCoroutine(naxuikisloty(limb));
                yield return new WaitForSeconds(1f);
            }

            



        }
        private IEnumerator naxuirani(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.damagePoints.Length; ++index)
                    limb.SkinMaterialHandler.damagePoints[index].z += Time.deltaTime * 0.8f;
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
            }
        }

        private IEnumerator naxuiogon(LimbBehaviour limb)
        {
            while ((double)limb.PhysicalBehaviour.BurnProgress > 0.100000001490116)
            {
                limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.0f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.PhysicalBehaviour.BurnProgress = 0.0f;
        }

        private IEnumerator naxuikisloty(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.AcidProgress > 0.100000001490116)
            {
                limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.8f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.AcidProgress = 0.0f;
        }

        private IEnumerator naxuignoi(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.RottenProgress > 0.100000001490116)
            {
                limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.8f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.RottenProgress = 0.0f;
        }


        private IEnumerator naxuipuli(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.bulletHolePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.bulletHolePoints.Length; ++index)
                {
                    limb.SkinMaterialHandler.bulletHolePoints[index].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[index].z, 0.05f);
                    limb.SkinMaterialHandler.bulletHolePoints[index].z += Time.deltaTime * 0.8f;
                }
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
            }
        }


    }
}