﻿using UnityEngine;

public struct Cyborg
{
    public static AudioClip SpartanLaserCharge;
    public static AudioClip SpartanLaserFire;
    public static AudioClip SpartanLaserExit;
    public static AudioClip[] EnergySwordHits;
    public static AudioClip EnergySwordIgnite;
    public static AudioClip[] PlasmaPistolFire;
    public static AudioClip[] PlasmaRifleFire;
    public static AudioClip[] NeedleFire;
    public static AudioClip[] NeedleExplode;
    public static AudioClip PlasmaRifleOverheat;
    public static AudioClip PlasmaPistolChargeStart;
    public static AudioClip PlasmaPistolLoop;
    public static AudioClip PlasmaPistolChargedShot;
    public static AudioClip TetrisGun;
    public static AudioClip RCjumping;
    public static Sprite EnergySwordBlade;
    public static Sprite[] Cttc;
    public static Sprite[] Cttc2;
    public static Sprite EnergySwordBlade2;
    public static Sprite EnergySwordPart;
    public static Sprite Needle;
    public static Sprite EnergySwordInvisible;
    public static void Initialise()
    {

        SpartanLaserCharge = ModAPI.LoadSound("cannon.wav");
        RCjumping = ModAPI.LoadSound("RCjump.wav");
        SpartanLaserFire = ModAPI.LoadSound("sfx/spartan_laser_fire.wav");
        SpartanLaserExit = ModAPI.LoadSound("sfx/spartan_laser_exit.wav");


        PlasmaRifleOverheat = ModAPI.LoadSound("sfx/plasma_rifle_overheat.wav");

        PlasmaPistolChargeStart = ModAPI.LoadSound("sfx/plasma_pistol_start.wav");
        PlasmaPistolLoop = ModAPI.LoadSound("GreenP.wav");
        EnergySwordIgnite = ModAPI.LoadSound("sfx.wav");
        PlasmaPistolChargedShot = ModAPI.LoadSound("sfx/plasma_pistol_charged.wav");

        EnergySwordHits = new[]{
            ModAPI.LoadSound("sfx/energy_sword_impact1.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact2.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact3.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact4.wav"),
        };

        PlasmaPistolFire = new[]{
            ModAPI.LoadSound("sfx/plasma_pistol1.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol2.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol3.wav"),
        };

        PlasmaRifleFire = new[]{
            ModAPI.LoadSound("sfx/plasma_rifle1.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle2.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle3.wav"),
        };

        NeedleFire = new[]{
            ModAPI.LoadSound("sfx/needler_fire1.wav"),
            ModAPI.LoadSound("sfx/needler_fire2.wav"),
            ModAPI.LoadSound("sfx/needler_fire3.wav"),
        };

        NeedleExplode = new[]{
            ModAPI.LoadSound("sfx/needle_explode1.wav"),
            ModAPI.LoadSound("sfx/needle_explode2.wav"),
            ModAPI.LoadSound("sfx/needle_explode3.wav"),
        };
        EnergySwordPart = ModAPI.LoadSprite("Ice.png");
        EnergySwordBlade = ModAPI.LoadSprite("IceSword.png");
        EnergySwordBlade2 = ModAPI.LoadSprite("StaffRet.png");
        EnergySwordInvisible = ModAPI.LoadSprite("th.png");
        TetrisGun = ModAPI.LoadSound("tetrisbomb2.wav");
        Needle = ModAPI.LoadSprite("th.png");
        Cttc = new[]{
            ModAPI.LoadSprite("t1.png"),
            ModAPI.LoadSprite("t2.png"),
            ModAPI.LoadSprite("t3.png"),
            ModAPI.LoadSprite("t4.png"),
            ModAPI.LoadSprite("t5.png"),
            ModAPI.LoadSprite("t6.png"),
            ModAPI.LoadSprite("t7.png"),
        };

        Cttc2 = new[]{
            ModAPI.LoadSprite("t11.png", 1f),
            ModAPI.LoadSprite("t22.png", 1f),
            ModAPI.LoadSprite("t33.png", 1f),
            ModAPI.LoadSprite("t44.png", 1f),
            ModAPI.LoadSprite("t55.png", 1f),
            ModAPI.LoadSprite("t66.png", 1f),
            ModAPI.LoadSprite("t77.png", 1f),
        };
    }
}
